use super::schema::member_classes;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, PartialOrd, Debug, Clone)]
#[table_name = "member_classes"]
pub struct MemberClass {
  ///
  pub id: uuid::Uuid,
  ///
  pub parent_id: Option<uuid::Uuid>,
  ///
  pub name: String,
  ///
  pub show: bool,
  ///
  pub created_at: i64,
  ///
  pub updated_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "member_classes"]
pub struct NewMemberClass {
  ///
  pub parent_id: Option<uuid::Uuid>,
  ///
  pub name: String,
  ///
  pub show: bool,
}

///
#[derive(AsChangeset, Debug, Clone)]
#[table_name = "member_classes"]
pub struct ModifyMemberClass {
  ///
  pub parent_id: Option<uuid::Uuid>,
  ///
  pub name: String,
  ///
  pub show: bool,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub name_like: Option<String>,
  ///
  pub show: Option<bool>,
}

///
#[derive(Debug, Clone)]
pub struct FindAll {
  ///
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::models::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::models::pagination::Sort>>,
}
