use super::schema::member_levels;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, PartialOrd, Debug, Clone)]
#[table_name = "member_levels"]
pub struct MemberLevel {
  ///
  pub id: uuid::Uuid,
  ///
  pub name: String,
  ///
  pub show: bool,
  ///
  pub sort_order: i32,
  ///
  pub created_at: i64,
  ///
  pub updated_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "member_levels"]
pub struct NewMemberLevel {
  ///
  pub name: String,
  ///
  pub show: bool,
  ///
  pub sort_order: i32,
}

///
#[derive(AsChangeset, Debug, Clone)]
#[table_name = "member_levels"]
pub struct ModifyMemberLevel {
  ///
  pub name: String,
  ///
  pub show: bool,
  ///
  pub sort_order: i32,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub name_like: Option<String>,
  ///
  pub show: Option<bool>,
}

///
#[derive(Debug, Clone)]
pub struct FindAll {
  ///
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::models::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::models::pagination::Sort>>,
}
